#ifndef DEF_MAIN
#define DEF_MAIN

#include <stdlib.h>
#include <stdio.h>
#include "cuda_runtime_api.h"

#define DIMENSION 3
#define X 0
#define Y 1
#define Z 2
#define TAILLE_MAX 1000
#define DISTANCE_MIN 0.2

static void HandleError( cudaError_t err, const char *file, int line ) 
{
	if (err != cudaSuccess) 
	{
		printf( "%s in %s at line %d\n", cudaGetErrorString( err ),
				file, line );
		exit( EXIT_FAILURE );
	}
}

#define HANDLE_ERROR( err ) (HandleError( err, __FILE__, __LINE__ ))

#endif